<?php
	/* Project: eversync
	 * This file is part of eversync.
		
		eversync is free software: you can redistribute it and/or modify
	    it under the terms of the GNU General Public License as published by
	    the Free Software Foundation, either version 3 of the License, or
	    (at your option) any later version.
	
	    eversync is distributed in the hope that it will be useful,
	    but WITHOUT ANY WARRANTY; without even the implied warranty of
	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	    GNU General Public License for more details.
	
	    You should have received a copy of the GNU General Public License
	    along with eversync.  If not, see <http://www.gnu.org/licenses/>.
	*/

	/* File-desc: core of eversync. Loads and starts all modules */
	/* Version: 0.01 */

// *** To be compatible to java use current_millis instead of Time() ***/
function current_millis() {
    //list($usec, $sec) = explode(" ", microtime());
    return time();//round(((float)$usec + (float)$sec) * 1000);
}
/* TODO Add deduplication.
 * Fileupload:
 * -Check if file exists
 * -If hash exists => Just link the fs entry with the filehash
 * -If not => Upload file
 * 
 * FS Entry removing:
 * -Just remove the fsentry
 * 
 * Garbecollecting:
 * -Every 10 minutes (or more depending on the access rate) check for unlinked files
 * -Exist =>Delete
 */ 

class Core{
		
		/* ### Member Vars ### */
			private $mDbMod;
			private $mComInterface;
			private $mWebInterface;
		
		/* ### constructor ### */
			function __construct(){
				$start = microtime(true);
				$this->init();
			//	echo "Script Runtime: ".(microtime(true)-$start);
			}	
			
		/* ### Private methods ### */
			private function isDektopClientRequest(){
				if(isset($_GET['dc']) && $_GET['dc']==true){
					return true;
				}
				return false;
			}			
			
		/* ### Public methods ### */
			function init(){
					include_once("errorHandler/ErrorHandler.inc");
					include_once("db/Database.inc");
					$this->setDbMod(new db\Database());					
				//Check if a client did this request
					if($this->isDektopClientRequest()){						
						include_once("comInterface/ComInterface.inc");	//Load ComInterface
						$this->setComInterface(new comInterface\ComInterface($this->getDbMod()->getDbConnection()));
					}else{						
						include_once("webInterface/WebInterface.inc"); //Load Webinterface
						$this->setWebInterface(new webInterface\WebInterface($this->getDbMod()->getDbConnection()));
					}
			}
		/* ### Setters and Getters ### */
			private function setDbMod($aMod){$this->mDbMod = $aMod;}
			function getDbMod(){return $this->mDbMod;}

			private function setComInterface($aMod){$this->mComInterface = $aMod;}
			function getComInterface(){return $this->mComInterface;}
			
			private function setWebInterface($aMod){$this->mWebInterface = $aMod;}			
			function getWebInterface(){return $this->mWebInterface;}	
		
		
	}
?>