<?php
	/* Project: eversync
	 * This file is part of eversync.
		
		eversync is free software: you can redistribute it and/or modify
	    it under the terms of the GNU General Public License as published by
	    the Free Software Foundation, either version 3 of the License, or
	    (at your option) any later version.
	
	    eversync is distributed in the hope that it will be useful,
	    but WITHOUT ANY WARRANTY; without even the implied warranty of
	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	    GNU General Public License for more details.
	
	    You should have received a copy of the GNU General Public License
	    along with eversync.  If not, see <http://www.gnu.org/licenses/>.
	*/

	/* File-desc: Provides administrative functions */
	namespace admin;
	include_once("admin/webInterface/WebInterface.inc");
	class Admin{
		/* Members Vars */
			private $mDbConn;
		
		/* Constructor */
			function __construct($aDbConn){
				$this->setDbMod($aDbConn);
			}
		
		
		/* Public Methods */			
			//-----------------------------------
			
			/**
			 * @desc Sets the default_max_user_space value
			 * @param int $aValue in Mb
			 * @return string
			 */
			public function setDefaultMaxUserSpace($aValue){
				$sqlQuery = "UPDATE config SET default_max_user_space= :val";
				$stmt = $this->getDbConn()->prepare($sqlQuery);
				$stmt->bandParam(':val',$aValue);
				$stmt->execute();
				return true;
			}
		
		/* Private Methods */
				
		
		/* Getters and Setters */
			private function setDbConn($aMod){$this->mDbConn = $aMod; }
			private function getDbConn(){return $this->mDbConn;}
		
	}
?>