<?php
	/* Project: eversync
	 * This file is part of eversync.
		
		eversync is free software: you can redistribute it and/or modify
	    it under the terms of the GNU General Public License as published by
	    the Free Software Foundation, either version 3 of the License, or
	    (at your option) any later version.
	
	    eversync is distributed in the hope that it will be useful,
	    but WITHOUT ANY WARRANTY; without even the implied warranty of
	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	    GNU General Public License for more details.
	
	    You should have received a copy of the GNU General Public License
	    along with eversync.  If not, see <http://www.gnu.org/licenses/>.
	*/
	namespace db\History;
	include_once( "db/history/HistoryEntry.inc");
	include_once("db/history/HistoryStore.inc");
		
	class History{
		
		/* ### Consts ### */
			const cTYPE_ADDED_FOLDER = 1;
			const cTYPE_ADDED_FILE=10;
			const cTYPE_DELETED = 2;
			const cTYPE_MODIFIED = 3;
			const cTYPE_RENAMED = 4;
		
		/* ### Member Vars ### */
			/**
			 * Database connection
			 * @var \PDO
			 */
			private $mDbConn;
			/**
			 * @var HistoryStore
			 */
			private $mHistoryStore;
			private $mUserId;
		/* ### Constructor ### */
			function __construct(\PDO $aDbConn,$aUserId){
				$this->setDbConn($aDbConn);
				$this->setHistoryStore(new HistoryStore($this->getDbConn()));
				$this->setUserId($aUserId);
			}	
		/* ### Public Methods ### */
			public function getHistory($aCount=0){
				return $this->getHistoryStore()->getEntries($this->getUserId(),$aCount);
			}
			
			//--------------------------------
			
			public function clearHistory(){
				$this->getHistoryStore()->clearHistory($this->getUserId());
			}
			
			//--------------------------------
			
			public function addHistoryEntry($aType,$aMsg){
				$this->getHistoryStore()->addEntry($aType, $aMsg, $this->getUserId());
			}
		
		/* ### Private Methods ### */
		
		
		/* ### Setter and Getter ### */		
			private function setDbConn($aVal){$this->mDbConn = $aVal;}
			private function getDbConn(){return $this->mDbConn;}
			
			private function setHistoryStore($aMod){$this->mHistoryStore = $aMod; }
			private function getHistoryStore(){return $this->mHistoryStore; }
		
			public function setUserId($aVal){$this->mUserId = $aVal;}
			private function getUserId(){return $this->mUserId;}
	}
?>