<?php
	/* Project: eversync
	 * This file is part of eversync.
		
		eversync is free software: you can redistribute it and/or modify
	    it under the terms of the GNU General Public License as published by
	    the Free Software Foundation, either version 3 of the License, or
	    (at your option) any later version.
	
	    eversync is distributed in the hope that it will be useful,
	    but WITHOUT ANY WARRANTY; without even the implied warranty of
	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	    GNU General Public License for more details.
	
	    You should have received a copy of the GNU General Public License
	    along with eversync.  If not, see <http://www.gnu.org/licenses/>.
	*/

	namespace db\History;
	
	class HistoryStore{
		/* ### Member Vars ### */
			/**
			 * Database connection
			 * @var \PDO
			 */
			private $mDbConn;
		/* ### Constructor ### */
			function __construct(\PDO $aDbConn){
				$this->setDbConn($aDbConn);
			}	
		/* ### Public Methods ### */
			public function clearHistory($aUserId){
				$sqlQuery = "DELETE FROM history WHERE user_id = :userId";
				$stmt = $this->getDbConn()->prepare($sqlQuery);
				$stmt->bindParam(':userId',$aUserId);
				
				/** Execute **/
					$stmt->execute();						
			}
			
			//------------------------------
			
			public function addEntry($aType,$aMsg,$aUserId){
				$sqlQuery = "INSERT INTO history (type,msg,userId,time) VALUES (?,?,?,?)";
				$stmt = $this->getDbConn()->prepare($sqlQuery);
				$stmt->execute(Array($aType,$aMsg,$aUserId,time()));
			}
		
			//-------------------------------
			
			public function getEntries($aUserId,$aMaxCount){
				if($aMaxCount == 0)
					$aMaxCount == 20;
				$sqlQuery = "SELECT * FROM history WHERE userId = ? ORDER BY time DESC, msg DESC LIMIT ?";
				$stmt =$this->getDbConn()->prepare($sqlQuery);
				$stmt->execute(Array($aUserId,$aMaxCount));
				$reArr = Array();
				$obj = $stmt->fetchALL(\PDO::FETCH_CLASS, '\db\history\HistoryEntry');
				foreach($obj as $fsEntry){
					$reArr[] = $fsEntry;
				}				
				return $reArr;
			}
			
		/* ### Private Methods ### */
		
		
		/* ### Setter and Getter ### */		
			private function setDbConn($aVal){$this->mDbConn = $aVal;}
			private function getDbConn(){return $this->mDbConn;}
		
	}
?>