<?php
	/* Project: eversync
	 * This file is part of eversync.
		
		eversync is free software: you can redistribute it and/or modify
	    it under the terms of the GNU General Public License as published by
	    the Free Software Foundation, either version 3 of the License, or
	    (at your option) any later version.
	
	    eversync is distributed in the hope that it will be useful,
	    but WITHOUT ANY WARRANTY; without even the implied warranty of
	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	    GNU General Public License for more details.
	
	    You should have received a copy of the GNU General Public License
	    along with eversync.  If not, see <http://www.gnu.org/licenses/>.
	*/

	/* File-desc: The intern page */
	namespace webInterface\internPage;
	
	include_once "webInterface/internPage/pageModules/PageHeader.inc";
	include_once "webInterface/internPage/pageModules/FileDownloader.inc";
	include_once "webInterface/internPage/pageModules/FolderDownloader.inc";
	
	use webInterface\internPage\pageModules\FolderDownloader;
	use webInterface\internPage\pageModules\JqueryUiDesignLoader;
	use webInterface\internPage\pageModules\FileDownloader;
	use db\fs\FileStructureHandler;
	use db\fs\FsHandler;
	use webInterface\internPage\pageModules\PageHeader;
	
	class InternPage{
	/* ### Member Vars ### */
			private $mDbConn;
			private $mUserId;
		/* ### Constructor ### */
			function __construct($aDbConn,$aUserId){
				$this->setDbConn($aDbConn);
				$this->setUserId($aUserId);
			}	
		
		/* ### Public Methods ### */
			public function show(){
				if($this->isDownload()){
					if(isset($_GET['filepath'], $_GET['filename'])){
						$path = $_GET['filepath'];
						$name = $_GET['filename'];
						$fsHandler = new FsHandler($this->getDbConn(),$this->getUserId());
						if($fsHandler->isFile($path, $name)){
							$fileDownloader = new FileDownloader($this->getDbConn());
							$fileDownloader->fileDownload($path,$name);
						}else{
							$folderDownloader= new FolderDownloader($this->getDbConn());
							$folderDownloader->folderDownload($path, $name);
						}
					}
				}else{				
					$template = file_get_contents("templates/intern/intern.html");
					/** Parse header **/
						$header = new PageHeader($this->getDbConn());
						$template = $header->parse($template);
					/** Load jquery ui design **/
						$designLoader = new JqueryUiDesignLoader($this->getDbConn());
						$template = $designLoader->parse($template,$this->getUserId());
					return $template;
				}
			}
		
		/* ### Private Methods ### */			
			private function isDownload(){
				if(isset($_GET['action']) && $_GET['action']=="download_file"){
					return true;
				}
				return false;
			}
			
			//------------------------------
			
			private function getFsList(){
				$fsHandler = new FsHandler($this->getDbConn(),$this->getWebInterface()->getUserId());
				$fsArr = $fsHandler->getFsList("/",0,true);
				$re = "";
				foreach($fsArr as $entry){
					/*** Check subfolders ***/
					$in = "";
					for($i = 0;$i < substr_count($entry->getPath(),"/");$i++){
						$in.=">>";
					}					
					$re .= $in.($entry->getType()==FileStructureHandler::FS_TYPE_FILE ? "Fi":"Fo")."  ".
					$entry->getPath()."  ".$entry->getName(). " Last change: ".$entry->getLastChange()."<br>";					
				}
				return $re;
			}
			
			//------------------------------
			
		
		/* ### Setters and Getters ### */
			private function setDbConn($aMod){$this->mDbConn = $aMod;}
			private function getDbConn(){return $this->mDbConn;}	
			
			private function setUserId($aId){$this->mUserId = $aId; }
			private function getUserId(){return $this->mUserId;}
	}
?>